//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
// 
// You should have received a copy of the GNU Lesser General Public License
// along with this program.  If not, see http://www.gnu.org/licenses/.
// 

#ifndef DOWNLOADGEN_H_
#define DOWNLOADGEN_H_

#include <TCPBasicClientApp.h>
#include <GenericAppMsg_m.h>
#include <chistogram.h>

enum
{
    CONNECT = 0,
    DRAW_PACKET = 1,
    SEND_PORTIONS = 2,
    CLOSE_SOCKET = 3
};

class DownloadGen: public TCPBasicClientApp {
public:
    cDoubleHistogram histogramOfDataSizes;
    cMessage *getRandomPacket;
    cMessage *sendPortion;
    double packetSize;
    double duration;
    double bitrate;
    double replyPacketSize;
    double replyBitrate;
    int numberOfPortions;
    int amountOfSentPortions;
    DownloadGen();
    virtual ~DownloadGen();
    void socketEstablished(int connId, void *ptr);
    void handleTimer(cMessage *msg);
};

#endif /* DOWNLOADGEN_H_ */
