#include "TCPSingleServer.h"
#include "GenericAppMsg_m.h"

Define_Module(TCPSingleServer);

TCPSingleServer::TCPSingleServer()
{
}
TCPSingleServer::~TCPSingleServer()
{

}
void TCPSingleServer::initialize(int stage)
{
    const char *localAddress = par("localAddress");
    int localPort = par("localPort");
    localPort = localPort;// + getIndex();

    serverSocket.setOutputGate(gate("tcpOut"));
    serverSocket.setDataTransferMode(TCP_TRANSFER_OBJECT);
    serverSocket.bind(localAddress[0] ? IPvXAddress(localAddress) : IPvXAddress(), localPort);
    serverSocket.setCallbackObject(this);
    serverSocket.listenOnce();
}



void TCPSingleServer::handleMessage(cMessage *msg)
{
    long sendData;


    if (msg->isSelfMessage())
    {
        //   bool doClose = appmsg->getServerClose();
        switch (msg->getKind()){

        case REPEAT:
            delete msg;

            if(amountOfSentPortions < numberOfPortions)
            {
                GenericAppMsg *packet;
                packet = new GenericAppMsg;
                packet->setBitLength(requestedBits);
                packet->setServerClose(false);
                delete packet->removeControlInfo();
                socketToClient->send(packet);
                amountOfSentPortions++;
                EV << "Zlecilem wyslanie" << endl;
                repeat = new cMessage("repeat");
                repeat->setKind(REPEAT);
                scheduleAt(simTime()+ 0.1, repeat);
            }else{
                GenericAppMsg *packet1= new GenericAppMsg;
                packet1->setBitLength(requestedBits);
                packet1->setServerClose(true);
                delete packet1->removeControlInfo();
                socketToClient->send(packet1);
                EV << "TRACE koncze odpowiedz i zamykam socket" << endl;
                end = new cMessage("end");
                end->setKind(END);
                scheduleAt(simTime(), end);
            }
            break;
        case TERMINATE:
            delete msg;
            GenericAppMsg *termpck;
            termpck = new GenericAppMsg;
            sendData = requestedBits*numberOfPortions;
            if (sendData <8){
                sendData = 8;
            }
            if (numberOfPortions <1){
                numberOfPortions = 1;
            }
            termpck->setBitLength(sendData);
            termpck->setServerClose(true);
            delete termpck->removeControlInfo();
            socketToClient->send(termpck);
            EV << "TRACE koncze odpowiedz i zamykam socket" << endl;
            end = new cMessage("end");
            end->setKind(END);
            scheduleAt(simTime()+ numberOfPortions*0.1, end);
            break;
        case ONE_MSG:
            delete msg;
            GenericAppMsg *onemsg;
            onemsg = new GenericAppMsg;
            onemsg->setBitLength(requestedBits);
            onemsg->setServerClose(true);
            delete onemsg->removeControlInfo();
            socketToClient->send(onemsg);
            EV << "TRACE koncze odpowiedz i zamykam socket" << endl;
            end = new cMessage("end");
            end->setKind(END);
            scheduleAt(simTime(), end);
            break;
        case END:
            delete msg;
            break;
        }

    }else{

        TCPSocket *socket = sockCollection.findSocketFor(msg);
        if (!socket)
        {
            socket = new TCPSocket(msg);
            socket->setOutputGate(gate("tcpOut"));
            socket->setDataTransferMode(TCP_TRANSFER_OBJECT);
            socket->setCallbackObject(this, socket);
            sockCollection.addSocket(socket);
        }
        socket->processMessage(msg);
    }

}

void TCPSingleServer::socketDataArrived(int connId, void *yourPtr, cPacket *msg, bool urgent)
{
    GenericAppMsg *appmsg = dynamic_cast<GenericAppMsg *>(msg);


    if (appmsg->getReplyDelay() == 0)
    {


        if (appmsg->getExpectedReplyLength() == 0){

            requestedBits = appmsg->getExpectedReplyLength();
            numberOfPortions = appmsg->getReplyDelay();
            delete appmsg;
            EV << "TRACE Pakiet konczacy" << endl;
            terminate = new cMessage("terminate");
            terminate->setKind(TERMINATE);
            scheduleAt(simTime(), terminate);
        }else{
            requestedBits = appmsg->getExpectedReplyLength();
            numberOfPortions = appmsg->getReplyDelay();
            delete appmsg;
            EV << "TRACE Pakiet konczacy" << endl;
            terminate = new cMessage("terminate");
            terminate->setKind(TERMINATE);
            scheduleAt(simTime(), terminate);

        }
    }else{

        amountOfSentPortions = 1;
        requestedBits = appmsg->getExpectedReplyLength();
        numberOfPortions = appmsg->getReplyDelay();
        delete appmsg;
        EV << "TRACE Data Arrived zaczynam odpowiedz" << endl;
        repeat = new cMessage("repeat");
        repeat->setKind(REPEAT);
        scheduleAt(simTime(), repeat);

    }
}

void TCPSingleServer::socketEstablished(int connId, void *yourPtr)
{

    TCPSocket *socket = (TCPSocket*)yourPtr;
    socketToClient = socket;
}
void TCPSingleServer::socketClosed(int connId, void *yourPtr)
{

    int localPort = par("localPort");
    const char *localAddress = par("localAddress");
    serverSocket.renewSocket();
    serverSocket.setOutputGate(gate("tcpOut"));
    serverSocket.setDataTransferMode(TCP_TRANSFER_OBJECT);
    serverSocket.bind(localAddress[0] ? IPvXAddress(localAddress) : IPvXAddress(), localPort);
    serverSocket.setCallbackObject(this);
    serverSocket.listenOnce();
}
void TCPSingleServer::socketPeerClosed(int connId, void *yourPtr)
{

    socketToClient->close();
}



