#ifndef __TCPSingleServer_H_
#define __TCPSingleServer_H_

#include <omnetpp.h>
#include "TCPCommand_m.h"
#include "TCPSocket.h"
#include "INETDefs.h"

#include <TCPSocketMap.h>

enum
{
    REPLY = 0,
    REPEAT = 1,
    END = 2,
    TERMINATE = 3,
    ONE_MSG = 4,
};

class TCPSingleServer : public cSimpleModule, public TCPSocket::CallbackInterface
{

protected:


    TCPSocket *socketToClient;
    TCPSocket serverSocket;
    TCPSocketMap sockCollection;

    long size_responseInformResponse;
    long size_responseGetParameterValue;
    long size_responseSetParameterValue;
    long size_responseEmpty;

    int dataLength;
    int numberOfPortions;
    int amountOfSentPortions;
    long requestedBits;

    simtime_t informRequestProcessingTime;
    simtime_t emptyPacketProcessingTime;
    simtime_t getParameterValuesResponseProcessingTime;
    simtime_t setParameterValuesResponseProcessingTime;

    cMessage *startSimulation;
    cMessage *repeat;
    cMessage *reply;
    cMessage *end;
    cMessage *terminate;
    cMessage *oneMsg;

    virtual void initialize(int stage);
    virtual void handleMessage(cMessage *msg);
    //virtual void finish();

    virtual void socketDataArrived(int connId, void *yourPtr, cPacket *msg, bool urgent);
    void socketEstablished(int connId, void *yourPtr);
    void socketPeerClosed(int connId, void *yourPtr);
    void socketClosed(int connId, void *yourPtr);
    //virtual void socketFailure(int connId, void *yourPtr, int code);

    //void initializeManagerFSM();
    //void rescheduleTimer(cMessage *timer, simtime_t time, short int msgKind);
public:
    TCPSingleServer();
    virtual ~TCPSingleServer();
};
















#endif
