//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
// 
// You should have received a copy of the GNU Lesser General Public License
// along with this program.  If not, see http://www.gnu.org/licenses/.
// 

#ifndef TCPSERVER_H_
#define TCPSERVER_H_

#include <TCPSrvHostApp.h>
#include <TCPSocketMap.h>



class TCPserver: public TCPSrvHostApp {
public:

    simtime_t delay;
      simtime_t maxMsgDelay;

      long msgsRcvd;
      long msgsSent;
      long bytesRcvd;
      long bytesSent;

      TCPSocket *socketToSink;

      //statistics:
      static simsignal_t rcvdPkSignal;
      static simsignal_t sentPkSignal;


    void sendOrSchedule(cMessage *msg, simtime_t delay);
    void handleMessage(cMessage *msg);
    void sendBack(cMessage *msg);
    TCPserver();
    virtual ~TCPserver();
};

#endif /* TCPSERVER_H_ */
