//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
// 
// You should have received a copy of the GNU Lesser General Public License
// along with this program.  If not, see http://www.gnu.org/licenses/.
// 

#ifndef TRAFFICDATA_H_
#define TRAFFICDATA_H_

struct SessionData
{
    int size_up;     /**> TCP size in uplink direction (bytes) */
    int size_down;   /**> TCP size in downlink direction (bytes) */
    int duration;    /**> Session duration (miliseconds) */
};

class TrafficData
{
    int *data;
    int n;
    unsigned int uniform(unsigned int, unsigned int);

public:
    /** Initialize the library */
    TrafficData();

    /** Generate TCP session data */
    SessionData generate();
};


#endif /* TRAFFICDATA_H_ */
