//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
// 
// You should have received a copy of the GNU Lesser General Public License
// along with this program.  If not, see http://www.gnu.org/licenses/.
// 

#include "UploadGen.h"
#include <iomanip>
#include "TrafficData.h"
#include "IPvXAddressResolver.h"
#include "TCP.h"

Define_Module(UploadGen);

UploadGen::UploadGen() {
    traf = new TrafficData();
    length = new cMessage();
    plik.open("res.txt");
    plik<<"uPacketSize"<<"\t"<<"uBitrate"<<"\t"<<"dPacketSize"<<"\t"<<"dBitrate"<<"\t"<<"dist duration"<<"\t"<<"real duration"<<"\n";

    plik2.open("TEMP.txt");
    plik2<<"uPacketSize"<<"\t"<<"uBitrate"<<"\t"<<"dPacketSize"<<"\t"<<"dBitrate"<<"\t"<<"dist duration"<<"\t"<<"real duration"<<"\n";
    NumberOfSockets = 0;

}

UploadGen::~UploadGen() {
    // TODO Auto-generated destructor stub
}

void UploadGen::connect(){

    socket.renewSocket();


    IPvXAddress destination;
    const char *connectAddress = par("connectAddress");
    int connectPort = par("connectPort");
    IPvXAddressResolver().tryResolve(connectAddress, destination);


    socket.readDataTransferModePar(*this);
    socket.setDataTransferMode(TCP_TRANSFER_OBJECT);
    socket.setCallbackObject(this);
    socket.setOutputGate(gate("tcpOut"));
    socket.bind(IPvXAddressResolver().resolve("source"), -1);
    socket.connect(destination, connectPort);



}

void UploadGen::initialize(int stage)
{
    counter = 0;
    sessionCount = 100000;
    TCPGenericCliAppBase::initialize(stage);
    //const char *localAddress = par("localAddress");
    srcPort = 1000;
    srcPort = srcPort + getParentModule()->getIndex();
    destPort = 8080;
    if (stage != 3)
        return;
    simtime_t startTime = par("startTime");
    startSimulation = new cMessage("timer");
    startSimulation->setKind(CONNECT);
    scheduleAt(startTime, startSimulation);
}

void UploadGen::socketEstablished(int connId, void *ptr)
{

    //TCPSocket *socket = (TCPSocket*)ptr;
    //socketToSink = socket;
    NumberOfSockets++;
    EV << "TRACE otwieram socket numer" << endl;
    EV <<  NumberOfSockets << endl;
    getRandomPacket = new cMessage("getRandomPacket");
    getRandomPacket->setKind(DRAW_PACKET);
    scheduleAt(simTime(), getRandomPacket);
}

void UploadGen::socketClosed(int connId, void *yourPtr)
{

    NumberOfSockets--;
    EV << "TRACE zamykam socket numer" << endl;
    EV <<  NumberOfSockets << endl;
    connection = new cMessage("connection");
    connection->setKind(CONNECT);
    scheduleAt(simTime(), connection);
    usedEphemeralPorts.clear();
}


void UploadGen::handleTimer(cMessage *msg)
{
    bitConv = 8;
    msConv = 1000;
    ms100Conv = 100;
    uPacketZero = 5;


    switch (msg->getKind())
    {
    case CONNECT:
        delete msg;
        EV << "starting session\n";
        counter++;
        if (counter == sessionCount+1){
            endSimulation();
        }
        EV << NumberOfSockets << endl;
        timeStart = SIMTIME_DBL(simTime());
        //socket.renewSocket();
        connect();
        break;
    case DRAW_PACKET:
        EV << "TRACE losuj pakiet" << endl;
        delete msg;
        SessionData sd;
        sd = traf->generate();
        duration1=  233;//sd.duration;
        duration =  duration1/ms100Conv;  //  sd.duration/ms100Conv;//normal (50,10);  //czas w 100s
        durationSec = duration1/msConv;
        uPacketSize = sd.size_up;///normal (5120,1024); //rozmiar w B
        dPacketSize = sd.size_down; //rozmiar w B

        uBitrate = uPacketSize/duration;
        dBitrate = dPacketSize/duration;
        numberOfPortions = (int)duration;

        EV << "TRACE dane " << uPacketSize << endl;
        EV << "uPacket size to " << uPacketSize << endl;
        EV << "dPacket size to " << dPacketSize << endl;
        EV << "duration from distribution to " << duration1 << endl;
        EV << "duration in seconds to " << duration << endl;
        EV << "uBitrate  to " << uBitrate << endl;
        EV << "dBitrate  to " << dBitrate << endl;
        EV << "Ilosc porcji  to " << numberOfPortions << endl;

        //plik2.setf(std::ios_base::fixed);
        plik2.open("TEMP.txt", std::ios::app);
        plik2<< uPacketSize <<"\t"<<uBitrate<<"\t"<<dPacketSize<<"\t"<<dBitrate<<"\t"<<duration1<<"\t"<<sessionDur<<"\n";
        plik2.close();

        histogramOfuDataSizes.collect(uPacketSize);
        histogramOfdDataSizes.collect(dPacketSize);

        histogramOfallDataSizes.collect(uPacketSize);
        histogramOfallDataSizes.collect(dPacketSize);
        bubble("Policzylem");
/*
        if (uBitrate>536 || dBitrate>536){

            EV << "Zbyt duy bitrate" << endl;
            strSend = new cMessage("strSend");
            strSend->setKind(STR_SEND);
            scheduleAt(simTime()+durationSec, strSend);

        }else{
*/
            if (duration1 < ms100Conv )
            {
                numberOfPortions = 0;
                EV << "time<100ms" << endl;
                msHund = new cMessage("msHund");
                msHund->setKind(MS_HUND);
                scheduleAt(simTime(), msHund);
                if(duration1 == 0){
                    EV << "TRACE Zlecilem zamykanie socketa" << endl;
                    closeSocket = new cMessage("closeSocket");
                    closeSocket->setKind(CLOSE_SOCKET);
                    scheduleAt(simTime(), closeSocket);
                }
            }else{

               if (uBitrate*bitConv <1){

                    EV << "uBitrate 0" << endl;
                    uBitrateZero = new cMessage("uBitrateZero");
                    uBitrateZero->setKind(UBIT_ZERO);
                    scheduleAt(simTime(), uBitrateZero);
                }else{
                    amountOfSentPortions = 0;
                    precast = new cMessage("precast");
                    precast->setKind(PRECAST);
                    scheduleAt(simTime(), precast);
                }
            }

    //    }
        //duration = 1;
        cliClose = false;
        servClose = false;
        break;

    case STR_SEND:
        delete msg;
        GenericAppMsg *send;
        if(uPacketSize == 0){
            uPacketSize = 0.2;
        }
        send = new GenericAppMsg("send");
        send->setBitLength(uPacketSize*bitConv);
        send->setExpectedReplyLength(dPacketSize*bitConv);
        send->setServerClose(false);
        socket.send(send);
        cliClose = true;
        if (servClose){
            EV << "TRACE Zlecilem zamykanie socketa" << endl;
            closeSocket = new cMessage("closeSocket");
            closeSocket->setKind(CLOSE_SOCKET);
            scheduleAt(simTime()+ durationSec, closeSocket);
        }

        break;
    case MS_HUND:
        EV << "TRACE czas ponizej 100s" << endl;
        delete msg;
        if (uBitrate*bitConv >=1 && dBitrate*bitConv >=1){
            uPacketZero = 1;
            numberOfPortions = 1;
            GenericAppMsg *msHundred;
            msHundred = new GenericAppMsg("msHundred");
            msHundred->setBitLength(uPacketSize*bitConv);
            msHundred->setExpectedReplyLength(dPacketSize*bitConv);
            msHundred->setReplyDelay(numberOfPortions);
            msHundred->setServerClose(false);
            socket.send(msHundred);
            cliClose = true;
            if (servClose){
                EV << "TRACE Zlecilem zamykanie socketa" << endl;
                closeSocket = new cMessage("closeSocket");
                closeSocket->setKind(CLOSE_SOCKET);
                scheduleAt(simTime()+ durationSec, closeSocket);
            }
        }else{
            if (uPacketSize>0){
                GenericAppMsg *msHundred;
                msHundred = new GenericAppMsg("msHundred");
                msHundred->setBitLength(uPacketSize*bitConv);
                msHundred->setExpectedReplyLength(dPacketSize*bitConv);
                msHundred->setReplyDelay(numberOfPortions);
                msHundred->setServerClose(false);
                socket.send(msHundred);
                cliClose = true;
                if (servClose){
                    EV << "TRACE Zlecilem zamykanie socketa" << endl;
                    closeSocket = new cMessage("closeSocket");
                    closeSocket->setKind(CLOSE_SOCKET);
                    scheduleAt(simTime(), closeSocket);
                }
            }else{
                if (dPacketSize>0){
                    uPacketZero = 1;
                    GenericAppMsg *msHundred;
                    msHundred = new GenericAppMsg("msHundred");
                    msHundred->setBitLength(uPacketZero*bitConv);
                    msHundred->setExpectedReplyLength(dPacketSize*bitConv);
                    msHundred->setReplyDelay(numberOfPortions);
                    msHundred->setServerClose(false);
                    socket.send(msHundred);
                    cliClose = true;
                    if (servClose){
                        EV << "TRACE Zlecilem zamykanie socketa" << endl;
                        closeSocket = new cMessage("closeSocket");
                        closeSocket->setKind(CLOSE_SOCKET);
                        scheduleAt(simTime()+ durationSec, closeSocket);
                    }
                }else{
                    cliClose = true;
                    if (servClose){
                        EV << "TRACE Zlecilem zamykanie socketa" << endl;
                        closeSocket = new cMessage("closeSocket");
                        closeSocket->setKind(CLOSE_SOCKET);
                        scheduleAt(simTime()+ durationSec, closeSocket);
                    }
                }
            }
        }
        break;
    case PRECAST:
        EV << "TRACE Precast" << endl;
        delete msg;
        if (dPacketSize == 0){
            servClose = true;
            GenericAppMsg *precast;
            precast = new GenericAppMsg("precast");
            precast->setBitLength(uBitrate*bitConv);
            precast->setServerClose(false);
            socket.send(precast);
            amountOfSentPortions = 1;
        }else{
            GenericAppMsg *precast;
            precast = new GenericAppMsg("precast");
            precast->setBitLength(uBitrate*bitConv);
            precast->setExpectedReplyLength(dBitrate*bitConv);
            precast->setReplyDelay(numberOfPortions);
            precast->setServerClose(false);
            socket.send(precast);
            amountOfSentPortions = 1;
        }
        if(numberOfPortions > 1) {
            if(numberOfPortions ==1){
                GenericAppMsg *precast;
                precast = new GenericAppMsg("precast");
                precast->setBitLength(uPacketSize*bitConv);
                precast->setExpectedReplyLength(dPacketSize*bitConv);
                precast->setReplyDelay(numberOfPortions);
                precast->setServerClose(false);
                socket.send(precast);
                EV << "TRACE Zlecilem zamykanie socketa" << endl;
                closeSocket = new cMessage("closeSocket");
                closeSocket->setKind(CLOSE_SOCKET);
                scheduleAt(simTime()+ 0.1, closeSocket);
            }else{
                EV << "TRACE Pakiet kontrolny - do wyslania" << endl;
                sendPortion = new cMessage("sendPortion");
                sendPortion->setKind(SEND_PORTIONS);
                scheduleAt(simTime()+ 0.1, sendPortion);
            }
        }else{
            cliClose = true;
            if (servClose){
                EV << "TRACE Zlecilem zamykanie socketa" << endl;
                closeSocket = new cMessage("closeSocket");
                closeSocket->setKind(CLOSE_SOCKET);
                scheduleAt(simTime(), closeSocket);
            }
        }
        break;

    case SEND_PORTIONS:
        EV << "TRACE wyslij porcje" << endl;
        delete msg;
        GenericAppMsg *packet;
        packet = new GenericAppMsg("data");
        packet->setBitLength(uBitrate*bitConv);
        packet->setServerClose(false);
        socket.send(packet);
        amountOfSentPortions++;
        if(amountOfSentPortions < numberOfPortions) {
            EV << "TRACE Zlecilem wyslanie" << endl;
            sendPortion = new cMessage("sendPortion");
            sendPortion->setKind(SEND_PORTIONS);
            scheduleAt(simTime()+ 0.1, sendPortion);
        }else{
            cliClose = true;
            if (servClose){
                EV << "TRACE Zlecilem zamykanie socketa" << endl;
                closeSocket = new cMessage("closeSocket");
                closeSocket->setKind(CLOSE_SOCKET);
                scheduleAt(simTime(), closeSocket);
            }
        }
        break;

    case UBIT_ZERO:
        EV << "TRACE uBitrate zero" << endl;
        delete msg;
        if(dBitrate*bitConv >= 1){
            uPacketZero = 1;
            GenericAppMsg *packet1;
            packet1 = new GenericAppMsg("data1");
            packet1->setBitLength(uPacketZero);
            packet1->setReplyDelay(numberOfPortions);
            packet1->setExpectedReplyLength(dBitrate*bitConv);
            packet1->setServerClose(false);
            socket.send(packet1);
            cliClose = true;
            if (servClose){
                EV << "TRACE Zlecilem zamykanie socketa" << endl;
                closeSocket = new cMessage("closeSocket");
                closeSocket->setKind(CLOSE_SOCKET);
                scheduleAt(simTime(), closeSocket);
            }
        }else{
            EV << "TRACE Zlecilem zamykanie socketa" << endl;
            closeSocket = new cMessage("closeSocket");
            closeSocket->setKind(CLOSE_SOCKET);
            scheduleAt(simTime()+durationSec, closeSocket);
        }
        break;
    case CLOSE_SOCKET:
        EV << "TRACE Zdarzenia zamykaj socket" << endl;
        delete msg;
        EV << socket.getState() << endl;
        if (socket.getState() == 6 ||socket.getState() == 7){
            break;
        }
        socket.close();
        EV << socket.getState() << endl;
        EV << "Zamykam socket zdarzenie Close" << endl;
        EV << NumberOfSockets  << endl;
        sessionDur = (SIMTIME_DBL(simTime()) - timeStart)*msConv;
        plik.setf(std::ios_base::fixed);
        plik.open("res.txt", std::ios::app);
        plik<< uPacketSize <<"\t"<<uBitrate<<"\t"<<dPacketSize<<"\t"<<dBitrate<<"\t"<<duration1<<"\t"<<sessionDur<<"\n";
        plik.close();
        /*
        connection = new cMessage("connection");
        connection->setKind(CONNECT);
        scheduleAt(simTime()+1, connection);
         */
        break;
    default:
        delete msg;
        throw cRuntimeError("Invalid timer msg: kind=%d", msg->getKind());
        break;
    }
}


void UploadGen::socketDataArrived(int connId, void *yourPtr, cPacket *msg, bool urgent)
{
    GenericAppMsg *appmsg = dynamic_cast<GenericAppMsg *>(msg);
    servClose = appmsg->getServerClose();
    delete msg;
    if (servClose && cliClose){

        EV << "TRACE Zlecilem zamykanie socketa" << endl;
        closeSocket = new cMessage("closeSocket");
        closeSocket->setKind(CLOSE_SOCKET);
        scheduleAt(simTime(), closeSocket);

    }

}
void UploadGen::finish() {

    histogramOfuDataSizes.recordAs("uPacketSize");
    histogramOfdDataSizes.recordAs("dPacketSize");
    histogramOfallDataSizes.recordAs("udPacketSize");

    histogramOfuBitrate.recordAs("uBitrate");
    histogramOfdBitrate.recordAs("dBitrate");
}
