//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
// 
// You should have received a copy of the GNU Lesser General Public License
// along with this program.  If not, see http://www.gnu.org/licenses/.
// 

#ifndef UPLOADGEN_H_
#define UPLOADGEN_H_

#include "TCPGenericCliAppBase.h"
#include "TCP.h"
#include <GenericAppMsg_m.h>
#include <chistogram.h>
#include <TrafficData.h>
#include <TCPSocketMap.h>
#include <fstream>
#include <omnetpp.h>
#include "TCPCommand_m.h"
#include "TCPSocket.h"
#include "INETDefs.h"
enum
{
    CONNECT = 0, //polaczenie
    DRAW_PACKET = 1, // wybranie rozkladu skorelowanych zmiennych
    SEND_PORTIONS = 2,// regularne wysylanie przy uBitrate i dBitrate >=1
    CLOSE_SOCKET = 3, //zamkniecie socketa
    UBIT_ZERO = 4, // gdy ubitrate = 0;
    DBIT_ZERO = 5, // gdy dbitrate = 0;
    PRECAST = 6,// precast wiadomosci = 0;
    CLIENT_CLOSED = 7, //sprawdzanie stanu zamkniecia socketa dla klienta i servera
    MS_HUND = 8, //gdy czas sesji < 100ms
    STR_SEND = 9 // proste wysanie
};

class UploadGen: public TCPGenericCliAppBase {
public:
    cDoubleHistogram histogramOfuDataSizes;
    cDoubleHistogram histogramOfdDataSizes;
    cDoubleHistogram histogramOfuBitrate;
    cDoubleHistogram histogramOfdBitrate;
    cDoubleHistogram histogramOfallDataSizes;
    cMessage *startSimulation;
    cMessage *getRandomPacket;
    cMessage *connection;
    cMessage *sendPortion;
    cMessage *closeSocket;
    cMessage *uBitrateZero;
    cMessage *dBitrateZero;
    cMessage *length;
    cMessage *precast;
    cMessage *clientClosed;
    cMessage *msHund;
    cMessage *strSend;

    double uPacketSize; //download packet
    double dPacketSize; // upload packet
    double duration;
    double duration1;
    double durationSec;
    double uBitrate; //uploadbitrate
    double dBitrate; //downloadbitrate
    double bytesRec;
    double replyPacketSize;
    double  replyBitrate;
    double  timeStart;
    double sessionDur;
    double  timeUZeroStart;
    double  timeUZeroEnd;
    double  timeUZeroDur;
    double msConv;
    double ms100Conv;
    double bitConv;
    double uPacketZero;
    int numberOfPortions;
    int amountOfSentPortions;
    int destPort;
    int srcPort;
    double counter;
    double sessionCount;
    bool servClose;
    bool cliClose;
    long NumberOfSockets;

    std::ofstream plik;
    std::ofstream plik2;

    TCPSocket serverSocket;
    TCPSocket *socketToSendReplyGet;
    TCPSocket *socketToSendReplySet;
    TCPSocketMap sockCollection;
    TCPSocket *socketToSink;
    TrafficData *traf;
    ushort lastEphemeralPort;
    std::multiset<ushort> usedEphemeralPorts;


    UploadGen();
    virtual ~UploadGen();

    void initialize(int stage);
    virtual void connect();
    void socketEstablished(int connId, void *ptr);
    void socketClosed(int connId, void *ptr);
    void socketDataArrived(int connId, void *yourPtr, cPacket *msg, bool urgent);
    //void socketPeerClosed(int connId, void *yourPtr);
    //void handleMessage(cMessage *msg);
    void handleTimer(cMessage *msg);
    void finish();
    //void connectSock();
};



#endif /* UploadGen_H_ */
